<%inherit file="/basedb/basetab" />
<%namespace name="buttons" file="/basedb/buttons2"  /> 
<%
import emen2.util.jsonutil
import collections

totalwork = sum(map(lambda x:float(x.get("p41_percent",0)),p41_projects))
ptypes = map(lambda x:x.get("p41_project_type"), p41_projects)
ptypes_s = set(ptypes)

# Index this
pubsbyrectype = collections.defaultdict(set)
for i in pubs:
	pubsbyrectype[i.rectype].add(i.name)


# Setup some additional reverse-indexes
projectsbypub = collections.defaultdict(set)
for k,v in pubsbyproject.items():
	for v2 in v:
		projectsbypub[v2].add(k)


projectsbyuser = collections.defaultdict(set)
for k,v in usersbyproject.items():
	for v2 in v:
		projectsbyuser[v2].add(k)


usersbygrant = collections.defaultdict(set)
for k,v in grantsbyuser.items():
	for v2 in v:
		usersbygrant[v2.name].add(k)


%>


<script type="text/javascript">
//<![CDATA[
	$(document).ready(function() {
		$('.editable').EditControl({});		
	});	
//]]>
</script>


<h1>P41 Report Summary</h1>

<p>
Report Year: 
${root.get("p41_year")}
</p>


<ul>
	<li class="label"><a href="${EMEN2WEBROOT}/record/${root.name}/p41report/years/"><img src="${EMEN2WEBROOT}/static/images/edit.png" alt="Edit" /> Edit projects included in this report</a></span></li>
	<li class="label"><a href="${EMEN2WEBROOT}/record/${root.name}/p41report/xml/">View XML</a></li>
</ul>



Total Projects: ${len(p41_projects)}

<ul>
	
<table>
	<thead>
		<tr>
			<th>Project Type</th>
			<th>Count</th>
			<th>% of Projects</th>
			<th>% of Effort</th>
		</tr>
	</thead>
	
	<tbody>
	
	% for i in ptypes_s:
		<tr>
			<td>${i}</td>
			<td>${ptypes.count(i)}</td>
			<td>${"%0.1f"%(ptypes.count(i)/float(len(p41_projects))*100)}%</td>
			<td></td>
		</tr>
	% endfor	

	<tr><td colspan="4"><hr /></td></tr>

	<tr>
		<td>Ready for report</td>
		<td>${len(filter(lambda x:x.get("p41_project_ready"), p41_projects))}</td>
		<td>${"%0.1f"%(len(filter(lambda x:x.get("p41_project_ready"), p41_projects))/float(len(p41_projects))*100)}%</td>
		<td></td>
	</tr>

	</tbody>
</table>

</ul>




<p>
Publications:

${len(pubs)}

<ul>

<table>
	<thead>
		<tr>
			<th>Publication Type</th>
			<th>Count</th>
			<th>%</th>
		</tr>
	</thead>
	
	<tbody>
	% for k,v in pubsbyrectype.items():
		<tr>
			<td>${k}</td>
			<td>${len(v)}</td>
			<td>${"%0.1f"%(float(len(v))/float(len(pubs))*100)} %</td>
		</tr>		
	% endfor
	</tbody>
</table>

</ul>

</p>


<p>
Total Percent Effort:
${sum(map(lambda x:float(x.get("p41_percent",0)), p41_projects))}%
</p>




<h1>Table of Contents</h1>

<h3><a href="#projects">Projects</a></h3>
<ul>
% for i in p41_projects:
	<li><a href="#project_${i.name}">${recnames.get(i.name)}</a></li>
% endfor
</ul>




<br /><br />
<h3><a href="#publications">Publications</a></h3>
<ul>
% for k,v in pubsbyrectype.items():
	
	<li>
		<h4><a href="#pubtype_${k}">${k}</a></h4>
	
		<ul>
	
		% for i in v:
			<li><a href="#publication_${i}">${recnames.get(i)}</a></li>
		% endfor

		</ul>
	</li>
	
% endfor
</ul>
		



<br /><br />
<h3><a href="#people">People</a></h3>
<ul>
% for v in sorted(users.values(), key=lambda x:x.displayname):
	<li><a href="#people_${v.name}">${v.displayname}</a></li>
% endfor	
</ul>



<br /><br />
<h3><a href="#grants">Grants</a></h3>

<ul>
	% for i in grants:
		<li>
			<a href="#grants_${i.name}">${recnames.get(i.name)}</a>
		</li>
	% endfor
</ul>


<br /><br />


<!-- ########### END ToC ########### -->




<h1><a name="projects"></a>Projects</h1>

% for project in p41_projects:

	<%call expr="buttons.singlepage('p41',recnames.get(project.name))">
		
	<h3><a name="project_${project.name}"></a><a href="${EMEN2WEBROOT}/record/${project.name}/">view record ${project.name}</a></h3>

	## <h3>Years included in P41 report:</h3>
	##<ul>
	##	% for j in groups.get("p41_grant_info",set()) & p41_project_parents.get(project.name):
	##		<li><a href="${EMEN2WEBROOT}/record/${j}">${allchildren_d.get(j,dict()).get("p41_year")}</a></li>
	##	% endfor
	##</ul>

	<div data-edit="true" data-name="${project.name}" data-viewtype="mainview" class="view">
		${rendered.get(project.name)}
	</div>

	
	<h3>Project users:</h3>
	% if not usersbyproject.get(project.name,[]):
		Strange -- this project does not seem to reference any users!
	% else:
		<ul>
			% for i in usersbyproject.get(project.name,[]):
				<li>
					${users[i].displayname} 
					(<a href="#people_${i}">view projecs/grants</a> | <a href="${EMEN2WEBROOT}/user/${i}">profile</a>)
				</li>
			% endfor
		</ul>
	% endif

	
	<h3>Publications (<a href="${EMEN2WEBROOT}/query/rectype==publication*/children.name.${project.name}*/">View all publications for all years</a>):</h3>
	
	% if not pubsbyproject.get(project.name, []):
		No publications for ${year}.
	% else:
		<ul>
		% for i in pubsbyproject.get(project.name, []):
			<li>
				${recnames.get(i)} 
				(<a href="#publication_${i}">view here</a> | <a href="${EMEN2WEBROOT}/record/${i}">view record ${i}</a>)
			</li>
		% endfor
		</ul>
	% endif

	
	</%call>

	<br /><br />
	
% endfor




<h1>Publications</h1>


% for k,v in pubsbyrectype.items():
		
	% for i in v:

		<%call expr="buttons.singlepage('pub',recnames.get(i))">

			<h3><a name="publication_${i}"><a href="${EMEN2WEBROOT}/record/${i}">view record ${i}</a></h3>
		
			<h3>Referenced by Projects:</h3>
			% if not projectsbypub.get(i, []):
				Strange -- publication does not seem to be referenced by any projects!
			% else:			
				<ul>
				% for q in projectsbypub.get(i, []):
					<li>
						${recnames.get(q)} 
						(<a href="#project_${q}">view here</a> | <a href="${EMEN2WEBROOT}/record/${i}">view record ${q}</a>)
					</li>
				% endfor
				</ul>					
			% endif
			
			
		</%call>
		
		<br /><br />
		
	% endfor
	
% endfor



<h1 id="people">People</h1>

% for user in sorted(users.values(), key=lambda x:x.displayname):

	<%call expr="buttons.singlepage('p41person', user.name)">

		<a name="people_${user.name}"></a>
		<a name="people_${user.record}"></a>

		<h3>
			${user.displayname} (<a href="${EMEN2WEBROOT}/user/${user.name}">view profile</a>)
		</h3>
	
		<p>
			Email: ${user.email}
		</p>
	
		<h3>Referenced by projects</h3>
		% if not  projectsbyuser.get(user.name, []):
			Strange -- user does not seem to be referenced by any projects!
		% else:
			<ul>
				% for j in projectsbyuser.get(user.name, []):
					<li>
						${recnames.get(j)} 
						(<a href="#project_${j}">view here</a> | <a href="${EMEN2WEBROOT}/record/${j}">view record ${j}</a>)
						</li>
				% endfor
			</ul>
		% endif


		<h3>Grants</h3>
		% if not grantsbyuser.get(user.name, []):
			No active grants for this person for this P41 year
		% else:
			<ul>
				% for i in grantsbyuser.get(user.name, []):
					<li>
						${recnames.get(i.name)} 
						(<a href="#grants_${i.name}">view here</a> | <a href="${EMEN2WEBROOT}/record/${i.name}">view record ${i.name}</a>)
					</li>
				% endfor
			</ul>
		% endif
	

	</%call>

% endfor



<h1><a name="grants"></a>Grants</h1>

% for grant in grants:

	<%call expr="buttons.singlepage('p41person', recnames.get(grant.name))">
	
		<h3><a name="grants_${grant.name}"></a>${recnames.get(grant.name)}</h3>
	
		<p>
			${rendered.get(grant.name)}
		</p>
	
		<h3>Referenced by users:</h3>
		% if not usersbygrant.get(grant.name):
			Strange -- this grant does not seem to reference any users!
		% else:
			<ul>
				% for user in usersbygrant.get(grant.name):
					<li>${users[user].displayname} (<a href="#people_${user}">view here</a>, <a href="${EMEN2WEBROOT}/user/${user}/">view profile</a>)</li>
				% endfor
			</ul>
		% endif
	
		<h3>References projects:</h3>
		<ul>
			% for q in projectsbygrant.get(grant.name):
				<li>${recnames.get(q)} (<a href="#project_${q}">view here</a>, <a href="${EMEN2WEBROOT}/record/${q}/">view record</a>)</li>
			% endfor
		</ul>
	
	
	</%call>
	
% endfor


<br /><br />



