<%inherit file="/pages/record" />
<%namespace name="buttons" file="/basedb/buttons2"  /> 

<% 
import emen2.util.jsonutil 
%>


<script type="text/javascript">
//<![CDATA[
	// init view edit
	caches['recnames'][${rec.name}] = ${emen2.util.jsonutil.encode(renderedrecname)};
	caches['displaynames'] = ${emen2.util.jsonutil.encode(displaynames)};
	$(document).ready(function() {
		record_init(${emen2.util.jsonutil.encode(rec)}, ${emen2.util.jsonutil.encode(rec.ptest())}, ${emen2.util.jsonutil.encode(edit)});
		$(".tilemap").TileMap({mode:'cached', controlsinset: false, size:256, name: ${rec.name}});
	});	
//]]>
</script>



<ul id="editbar" class="clearfix">

	% if rec.writable():
		<li class="edit">
			<span class="clickable label" data-name="${rec.name}">
				<img src="${EMEN2WEBROOT}/static/images/edit.png" alt="Edit" /> Edit
			</span>
		</li>
	% endif

	% if create:
		<li class="newrecordselect">
			<span class="clickable label">
				New
				<img src="${EMEN2WEBROOT}/static/images/caret_small.png" alt="^" />
			</span>
		</li>
	% endif

	<li class="relationships">
		<span class="clickable label">
			Relationships
			<img src="${EMEN2WEBROOT}/static/images/caret_small.png" alt="^" />
		</span>
	</li>


	<li class="permissions">
		<span class="clickable label">
			Permissions
			<img src="${EMEN2WEBROOT}/static/images/caret_small.png" alt="^" />
		</span>
	</li>

	<%
	attachments = []
	# cheap filtering....
	for k in rec.getparamkeys():
		v = rec[k]
		if hasattr(v, "__iter__"):
			attachments.extend(x for x in v if 'bdo:' in str(x))
		elif "bdo:" in unicode(v):
			attachments.extend([v])
	%>


	<li class="attachments">
		<span class="clickable label">
			<span id="attachment_count">${len(attachments)}</span>
			Attachments
			<img src="${EMEN2WEBROOT}/static/images/caret_small.png" alt="^" />
		</span>
	</li>


	<li class="tools">
		<span class="clickable label">
			Tools
			<img src="${EMEN2WEBROOT}/static/images/caret_small.png" alt="^" />
		</span>
		<div class="hidden">			
			<h4>Tools</h4>

			<ul>
				% if rec.rectype == "p41_grant_info":
					<li><a href="${EMEN2WEBROOT}/record/${rec.name}/p41report/">P41 Grant Report</a></li>
					<li><a href="${EMEN2WEBROOT}/record/${rec.name}/p41report/years/">P41 Grant Report: Projects Included</a></li>
				% endif

				% if rec.rectype == "ccd":
					<li><a href="${EMEN2WEBROOT}/record/${rec.name}/boxer/">Web.Boxer</a><br /><br /></li>
				% endif

				<li><a href="${EMEN2WEBROOT}/record/${rec.name}/email/">Email Users</a></li>
				<li><a href="${EMEN2WEBROOT}/query/name==${rec.name}/files/">View / Download all files</a></li>
				<li><a href="${EMEN2WEBROOT}/query/children.name.${rec.name}*/files/">View / Download all files in children</a></li>
				<li><a href="${EMEN2WEBROOT}/record/${rec.name}/publish/">Manage Public Data</a></li>
				
				% if rec.isowner():
					<li><a href="${EMEN2WEBROOT}/record/${rec.name}/delete/" class="delete">Delete this record</a><br /><br /></li>
				% endif
				
			</ul>
			
			<h4>Common Queries:</h4>

			<ul>
				<li><a href="${EMEN2WEBROOT}/sitemap/${rec.name}/">Child tree</a></li>
				<li><a href="${EMEN2WEBROOT}/sitemap/${rec.name}/?recurse=3">Child tree (Semi-expanded)</a></li>
				<li><a href="${EMEN2WEBROOT}/sitemap/${rec.name}/?recurse=-1">Child tree (Expanded)</a></li>
				<li><a href="${EMEN2WEBROOT}/query/children.name.${rec.name}*/">Child records, sorted by creation time</a></li>
				<li><a href="${EMEN2WEBROOT}/query/children.name.${rec.name}*/?sortkey=modifytime">Child records, sorted by last modification</a></li>
				<li><a href="${EMEN2WEBROOT}/query/children.name.${rec.name}*/rectype.is.labnotebook/">Child lab notebooks</a></li>
				<li><a href="${EMEN2WEBROOT}/query/children.name.${rec.name}*/rectype.is.image_capture*/">Child images (ccd, scan, tomogram)</a></li>
				<li><a href="${EMEN2WEBROOT}/query/children.name.${rec.name}*/rectype.is.grid_imaging/">Child grid imaging sessions</a></li>
				<li><a href="${EMEN2WEBROOT}/query/children.name.${rec.name}*/?xparam=ctf_defocus_measured&amp;yparam=ctf_bfactor">Child images, plot B-Factor vs. Defocus</a></li>
				<li><a href="${EMEN2WEBROOT}/query/rectype.is.${rec.rectype}/">${rec.rectype} records</a></li>
				<li><a href="${EMEN2WEBROOT}/query/rectype.is.${rec.rectype}/creator.is.${rec.get('creator')}/">${rec.rectype} records, created by ${rec.get('creator')}</a></li>
				<li><a href="${EMEN2WEBROOT}/query/rectype.is.${rec.rectype}/creator.is.${LOGINUSER}/">${rec.rectype} records, created by me</a></li>		
			</ul>

		</div>
	</li>
	

	<%
	nicenames = {
		"tabularview": "Table View (tabularview)",
		"mainview": "Main Protocol Definition (mainview)",
		"recname": "Short description (recname)",
		"dicttable": "Key/value table (dicttable)",
		"defaultview": "Default view"
	}
	%>


	<li class="selectview" style="border-right-color:white;padding-right:0px;">
		<span class="clickable label">
			${rec.rectype}
			<img src="${EMEN2WEBROOT}/static/images/caret_small.png" alt="^" />
		</span>
		<div class="hidden" style="width:300px">
			<p><a href="${ctxt.reverse('RecordDef',name=rec.rectype)}">${rec.rectype} protocol page</a></p>
			<p>View:
				<ul>
				% for i in sorted(set(recdef.views.keys()+['mainview', 'dicttable'])):
					<li class="clickable" data-viewtype="${i}">${nicenames.get(i, i)}</li>	
				% endfor
				</ul>
			</p>
		</div>
	</li>

	<li class="dicttable">
		<span class="clickable" style="display:inline" data-viewtype="dicttable"><img src="${EMEN2WEBROOT}/static/images/table.png" alt="^" /></span>
	</li>

	<li class="creator">
			<span class="clickable label">
				% if rec.get('modifytime'):	
					${displaynames.get(rec.get('modifyuser'), '(%s)'%rec.get('modifyuser'))} @ ${rec.get('modifytime', '')[:10]}
				% else:
					${displaynames.get(rec.get('creator'), '(%s)'%rec.get('creator'))} @ ${rec.get('creationtime', '')[:10]}
				% endif
				<img src="${EMEN2WEBROOT}/static/images/caret_small.png" alt="^" />
			</span>
		
		<div class="hidden">

			<p>
				Created by <a href="${"%s/user/%s"%(EMEN2WEBROOT,rec.get('creator'))}">
				${displaynames.get(rec.get('creator'), '(%s)'%rec.get('creator'))}</a> @ ${rec.get('creationtime')}
			</p>

			% if rec.get('modifytime'):
				<p>
					Last revised by <a href="${"%s/user/%s"%(EMEN2WEBROOT,rec.get('modifyuser'))}">
					${displaynames.get(rec.get('modifyuser'), '(%s)'%rec.get('modifyuser'))}</a> @ ${rec.get('modifytime')}
				</p>
				<p>
					View <a href="${EMEN2WEBROOT}/record/${rec.name}/history/">revision history</a>
				</p>				
			% endif
		</div>			
	</li>
	
	
	% if len(siblings)>1 and rec.name in siblings:
	
		<%
			pos = siblings.index(rec.name)
		%>
		
		<li class="siblings floatright" data-sibling="${sibling}">
				% if pos > 0:
					<a class="chevron" href="${EMEN2WEBROOT}/record/${siblings[pos-1]}/?sibling=${sibling}">&lsaquo;</a> 
				% endif

				<span class="clickable label">
					${pos+1} of ${len(siblings)}
				</span>

				% if pos+1 < len(siblings):
					<a class="chevron" href="${EMEN2WEBROOT}/record/${siblings[pos+1]}/?sibling=${sibling}">&rsaquo;</a> 
				% endif
		</li>
	% endif


</ul><div id="editbar_bottom"></div>


% if rec.get('deleted'):
	<div class="notify deleted">Deleted Record</div>
% endif



% if 'publish' in rec.get('groups', []):
	<div class="notify">Record marked as Published Data</div>
% endif


% if 'authenticated' in rec.get('groups', []):
	<div class="notify">Any authenticated user can access this Record</div>
% endif



% if rec.get('file_binary_image'):

	<div style="position:relative">
		<div class="tilemap" style="height:512px;overflow:hidden" data-bdo="${rec.get('file_binary_image')}"></div>
	</div>

	<h1></h1>
% endif





<div id="rendered" class="view" data-viewtype="${viewtype}" data-name="${rec.name}" ${['', 'data-edit="true"'][rec.writable()]}>
	${rendered}
</div>




<p></p>




% if pages_comments:
	${buttons.all(pages_comments)}
% endif





