# $Id: emen2control.py,v 1.15 2011/05/06 02:45:41 irees Exp $

#!/usr/bin/python
import os
import time
import urllib
import time
import sys
import traceback
import subprocess
import getpass
import httplib
import urllib
import urllib2
import xmlrpclib



def trykill(pid, signall, waittime):
	try:
		os.kill(pid, signall)
		return True
	except Exception, inst:
		g.error("\terror: %s"%inst)
		time.sleep(waittime)



def notifycallback():
	# email or SMS admin...
	g.info("Note: !!")



def readpid():
	pid = None
	try:
		f = open(g.paths.EMEN2JOBFILE, "r")
		pid = int(f.readlines()[-1].strip())
		f.close()
	except:
		pass
	return pid



def ping():
	try:
		db = xmlrpclib.ServerProxy("http://%s:%s%s/RPC2"%('localhost', g.EMEN2PORT, g.EMEN2WEBROOT), allow_none=1)
		t = db.gettime()
	except:
		return False
	return True



def start():
	with open(g.paths.EMEN2ERRLOG, 'w') as errfile:
		errfile.truncate()

		if ping():
			g.info("Server appears to be running; manual restart necessary")
			return

		g.info("Starting EMEN2 server")

		try:
			try:
				newpid = os.fork()
				if newpid > 0:
					return
			except OSError,e:
				g.error('First fork failed, exiting')
				g.error('err msg: %s' % e)
				return

			os.setsid()
			os.umask(0)

			g.log.capturestdout()
			g.log.closestdout()
			os.close(0)
			os.close(1)
			os.close(2)

			try:
				newpid = os.fork()
				if newpid > 0:
					pidfile = g.paths.EMEN2JOBFILE
					g.info("Writing newpid: %s -> %s"%(newpid, pidfile))
					with file(pidfile, 'w') as pidfile:
						pidfile.seek(0)
						pidfile.write('%s'%newpid)
					return

			except OSError:
				g.error('Second fork failed, exiting')
				return


			import emen2.web.server
			#emen2.web.server.inithttpd()
			server = emen2.web.server.EMEN2Server()


		except Exception, e:
			sys.stderr = errfile
			sys.stdout = sys.stderr
			sys.stderr.seek(0)
			traceback.print_exc()
			return





def log_archive():
	import emen2.db.database
	import emen2.db.config

	# Open DB Env
	dbenv = emen2.db.database.EMEN2DBEnv(maintenance=True)
	dbenv.log_archive(remove=True, checkpoint=True)
	dbenv.close()
	
	#ddb = emen2.db.database.DB(maintenance=True)
	#ddb.bdbs.log_archive(remove=True, checkpoint=True)
	#ddb.close()




def reindex():
	pass
	# import emen2.db.admin
	# db = emen2.db.admin.opendb()
	# with db:
	# 	txn = db._gettxn()
	# 	ctx = db._getctx()
	# 	db._db._rebuild_all(ctx=ctx, txn=txn)




def resetpw(name):
	pass
	#import emen2.db.config
	#parser = emen2.db.config.DBOptions()
	#parser.add_option("--user", type="string", help="Account to reset password", default="root")
	#(options, args) = parser.parse_args()
	# print "Changing password for %s"%name
	# newpass = getpass.getpass("New password: ")
	# 
	# import emen2.db.admin
	# db = emen2.db.admin.opendb()
	# db.setpassword("", newpass, name=name)






def main():

	global g
	import emen2.db.config
	parser = emen2.db.config.DBOptions()
	parser.add_option("--ping", action="store_true", help="Make sure the DB is running before any action")
	parser.add_option("--noping", action="store_true", help="Make sure the DB is dead before any action")
	parser.add_option("--log_archive", action="store_true", help="Archive completed log files")
	parser.add_option("--start", action="store_true", help="Start server")
	parser.add_option("--shutdown", action="store_true", help="Stop server")
	parser.add_option("--stop", dest="shutdown", action="store_true", help="Stop server")
	parser.add_option("--restart", action="store_true", help="Restart server")
	parser.add_option("--resetpw", type="string", help="Reset password for user")
	#parser.add_option("--reindex", action="store_true", help="Rebuild ALL indexes")
	(options, args) = parser.parse_args()
	if 'start' in args:
		options.start = True
	elif 'stop' in args:
		options.stop = True
	elif 'restart' in args:
		options.restart = True

	g = emen2.db.config.g()

	options.pid = readpid()

	#if options.reindex:
	#	reindex()
	#	return

	if options.resetpw:
		resetpw(options.resetpw)
		return

	if options.ping or options.noping:
		pingresult = ping()
		
	if options.ping and not pingresult:
		g.info("Server ping failed!")
		return

	if options.noping and pingresult:
		g.info("Server is still up!")
		return

	if options.restart or options.shutdown:
		waittime = 1

		if not options.pid:
			g.info("No server PID; Manual kill may be necessary")

		else:
			g.info("Attempting to end process %s"%options.pid)
			success = False
			for count in range(10):
				success = trykill(options.pid, 1, waittime)
				options.recover = True

			if not success:
				g.info("\tNo success after %s retries (%s seconds); sending sigkill"%(count, count*waittime))
				success = trykill(options.pid, 9, waittime)

			if success:
				os.unlink(g.paths.EMEN2JOBFILE)

	if options.restart or options.start:
		start()

	if options.log_archive:
		log_archive()






if __name__ == "__main__":
	main()

__version__ = "$Revision: 1.15 $".split(":")[1][:-1].strip()
